Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## prea.recommender
Class CustomRecommender

    java.lang.Object
      prea.recommender.CustomRecommender

All Implemented Interfaces:
  Recommender

    public class CustomRecommender

extends java.lang.Object
implements Recommender

This is a skeleton class for user-defined custom recommenders. You may copy this class if you want to implement more than one class. Please look at the "COMMENT FOR AUTHORS" in each method carefully before coding your algorithm.

Since:
  2012. 4. 20
Version:
  1.1
Author:
  Joonseok Lee

Field Summary
`int` | `itemCount` The number of items.
`double` | `maxValue` Maximum value of rating, existing in the dataset.
`double` | `minValue` Minimum value of rating, existing in the dataset.
`SparseMatrix` | `rateMatrix` Rating matrix for each user (row) and item (column)
`int` | `userCount` The number of users.

Constructor Summary
`CustomRecommender(int uc, int ic, double max, double min)` Construct a customized recommender model with the given data.

Method Summary
`void` | `buildModel(SparseMatrix rm)` Build a model with the given data and algorithm.
`EvaluationMetrics` | `evaluate(SparseMatrix testMatrix)` Evaluate the designated algorithm with the given test data.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### rateMatrix

    public SparseMatrix rateMatrix

  Rating matrix for each user (row) and item (column)

### userCount

    public int userCount

  The number of users.

### itemCount

    public int itemCount

  The number of items.

### maxValue

    public double maxValue

  Maximum value of rating, existing in the dataset.

### minValue

    public double minValue

  Minimum value of rating, existing in the dataset.

Constructor Detail

### CustomRecommender

    public CustomRecommender(int uc,
                             int ic,
                             double max,
                             double min)

  Construct a customized recommender model with the given data.

  Parameters:
    `uc` - The number of users in the dataset.
    `ic` - The number of items in the dataset.
    `max` - The maximum rating value in the dataset.
    `min` - The minimum rating value in the dataset.

Method Detail

### buildModel

    public void buildModel(SparseMatrix rm)

  Build a model with the given data and algorithm.

  Specified by:
    `buildModel` in interface `Recommender`
  Parameters:
    `rm` - The rating matrix with train data.

### evaluate

    public EvaluationMetrics evaluate(SparseMatrix testMatrix)

  Evaluate the designated algorithm with the given test data.

  Specified by:
    `evaluate` in interface `Recommender`
  Parameters:
    `testMatrix` - The rating matrix with test data.
  Returns:
    The result of evaluation, such as MAE, RMSE, and rank-score.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD